<template>
  <div v-if="loaded" class="d-flex flex-column mx-3">
    <p>ส่งคำร้องขอความช่วยเหลือ</p>
    <span class="notation">* ไม่บังคับ</span>
    <v-select v-model="requestId" :items="requestList" variant="solo" label="รายการยืม" density="compact"
      item-title="id" item-value="id" clearable>
      <template v-slot:item="{ props }">
        <v-list-item v-bind="props"></v-list-item>
      </template>
    </v-select>
    <v-form @submit.prevent="sendHelp">
      <v-text-field v-model="title" variant="solo" label="เรื่อง" clearable></v-text-field>

      <v-textarea v-model="description" label="ข้อความ" variant="solo" clearable></v-textarea>
      <v-btn :loading="sendLoading" :disabled="!isFormValid" type="submit" class="btn-help"  color="#fcc200" block>ส่งคำร้อง</v-btn>
    </v-form>

    <nuxt-link v-if="helpList" to="/help-requests" class="link mt-2">
      <v-btn :loading="sendLoading" type="submit" class="btn-help" block>รายการคำร้อง</v-btn>
    </nuxt-link>

    <v-col cols="auto">
      <v-dialog v-model="success" transition="dialog-top-transition" max-width="275">

        <template v-slot:default>
          <v-card rounded="xl">
            <div class="pb-5 text-center">
              <v-icon class="my-6" color="success" icon="mdi-check-circle-outline" size="128"></v-icon>
              <div class="t-text">ส่งคำร้องเรียบร้อย</div>
            </div>
          </v-card>
        </template>
      </v-dialog>
    </v-col>
  </div>
</template>

<script setup>
useHead({
  title: "Equipment | ศูนย์ช่วยเหลือ",
  meta: [{ name: "description", content: "ศูนย์ช่วยเหลือ" }],
});
definePageMeta({
  middleware: "auth",
});

import { ref, onMounted } from "vue";
import axios from "axios";

const url = useStrapiUrl();
const token = useStrapiToken();

const title = ref()
const description = ref()
const requestId = ref(null)
const sendLoading = ref(false)

const requestList = ref([])
const loaded = ref(false)
const success = ref(false)

const helpList = ref(false)

const isFormValid = computed(() => {
  return (
      !!title.value &&
      !!description.value
  );
});

async function sendHelp() {
  sendLoading.value = true;
  await new Promise((resolve) => setTimeout(resolve, 500));
  sendLoading.value = false;

  const user = useStrapiUser();
  console.log("user : ", user.value.id);
  console.log("message : ", description.value);

  const data = {
    title: title.value,
    description: description.value,
  };

  if (requestId.value) {
    data.request = {
      connect: [requestId.value],
    };
  }

  try {
    await axios.post(`${url}/helps`, {
      data,
    }, {
      headers: {
        Authorization: `Bearer ${token.value}`,
      },
    }).then(async (response) => {
      await axios.put(`${url}/users/${user.value.id}`, {
        helps: {
          connect: [response.data.data.id]
        }
      }, {
        headers: {
          Authorization: `Bearer ${token.value}`,
        }
      })
    })
  } catch (error) {
    console.log(error);
  } finally {
    console.log("Sended Help Success")
    success.value = true;
    setTimeout(() => {
      success.value = false;
      location.reload();
    }, 2000);
  }
}

async function getRequest() {
  await axios
    .get(`${url}/users/me`, {
      params: {
        fields: {
          0: "id",
        },
        populate: {
          requests: {
            fields: {
              0: "id",
            },
          },
        },
      },
      headers: {
        Authorization: `Bearer ${token.value}`,
      },
    })
    .then((response) => {
      requestList.value = response.data.requests;
    });
}

async function getRole() {
  const response = await axios.get(`${url}/users/me`, {
    params: {
      populate: {
        role: {
          fields: {
            5: "id"
          }
        }
      },
    },
    headers: {
      Authorization: `Bearer ${token.value}`,
    },
  });

  if (response.data.role.id === 3){
    helpList.value = true
  } else {
    helpList.value = false
  }
}

onMounted(async () => {
  await getRequest();
  await getRole();
  loaded.value = true;
});
</script>

<style scoped>
p {
  padding: 5px;
}

.notation {
  font-size: 12px;
  color: gray;
  padding-left: 10px;
}

.btn-help {
  font-size: 16px;
}

.t-text {
  font-size: 24px;
  font-weight: bold;
}

.link {
  text-decoration: none;
  color: black;
}
</style>
